/*    256 Sample    */ 
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdio.h>
#include <math.h>
#define X       800
#define Y       400
#define NFRE    10
#define MAX     50000
#define ratio   20
static Display  *disp;
static Window   win,root;
static Colormap cmap;
static GC       gc;
static XColor   color[256];
static XSetWindowAttributes     atr;

void main(argc,argv)
int argc;
char *argv[];
{
        int atoi(),itt,wai,c,max[MAX],min[MAX],k,i,j,n,xd1,xd2,yd1,yd2,dummy;
        float x0,x1,x2,xq,xrat,y0,y1,y2,yq,yrat,rat,xsid,ysid,xwid,ywid,xmax,ymax,ymin,xmin;
        float u[MAX],v[MAX],vel,vv,vmax,atof(), dx[MAX],dy[MAX],x[MAX],y[MAX];
        FILE  *fp;
        char filename[80],temp[256];

        fp=fopen(argv[1],"r");
        i = 0;
        for ( ;; )
        {
                if ( fgets(temp,78,fp)==NULL )
                {
                        fclose(fp);
                        break;
                }
                if ( temp[0] == ';' || temp[0] <= 31 || temp[1] == 0 ) continue;                      if ( temp[0] == 'b' ) break;

                        sscanf(temp,"%f %f %f %f",&dx[i],&dy[i],&u[i],&v[i]);
                        i++;
        }
        n=i;
        
        for(i=0;i<n;i++)
        {
                x[i]=dx[i]*100.0;
                y[i]=dy[i]*100.0;
                u[i]=(u[i]-atof(argv[2]));
                v[i]=v[i];
        }
	itt=atoi(argv[4]);
        n=i/itt;

        for(c=0;c<800;c++)
        {
                max[c]=-9999;
                min[c]=9999;
        }

        disp=XOpenDisplay(NULL);

        cmap=DefaultColormap(disp,0);
        
        for(c=0;c<50;c++)
        {       
                color[c].green=65353-(50-c)*(50-c)*65535/2500;
                color[c].red=0;
                color[c].blue=65535;
                XAllocColor(disp,cmap,&color[c]);
        }

        for(c=50;c<100;c++)
        {       
                color[c].green=65535;
                color[c].red=0;
                color[c].blue=65535-(c-50)*(c-50)*65535/2500;
                XAllocColor(disp,cmap,&color[c]);
        }

        for(c=100;c<150;c++)
        {       
                color[c].green=65535;
                color[c].red=65535-(150-c)*(150-c)*65535/2500;
                color[c].blue=0;
                XAllocColor(disp,cmap,&color[c]);
        }

        for(c=150;c<200;c++)
        {       
                color[c].green=65353-(c-150)*(c-150)*65535/2500;
                color[c].red=65535;
                color[c].blue=0;
                XAllocColor(disp,cmap,&color[c]);
        }


        root=DefaultRootWindow(disp);
        win=XCreateSimpleWindow(disp, root,0,0,X,Y,1,BlackPixel(disp,0),BlackPixel(disp,0));

        atr.backing_store=Always;
        XChangeWindowAttributes(disp,win , CWBackingStore,&atr);
        XMapWindow(disp,win);
        gc=XCreateGC(disp,win,0,0);

        c=30;
        XSetForeground(disp,gc,color[c].pixel);

        xmax=x[0];
        xmin=x[0] ;
        ymin=y[0] ;
        ymax=y[0] ;

        for(k=1;k<n;k++)
        {
                if(x[k]>xmax) xmax=x[k];
                if(x[k]<=xmin) xmin=x[k];
                if(y[k]>ymax) ymax=y[k];
                if(y[k]<=ymin) ymin=y[k];
        }
        xwid=xmax-xmin;
        ywid=ymax-ymin;

        xrat=X/xwid*0.8;
        yrat=Y/ywid*0.8;

        if(xrat>yrat)
                rat=yrat;
        else
                rat=xrat;
        
        xsid=(X-xwid*rat)/2.0;
        ysid=(Y-ywid*rat)*atof(argv[5]);

/*      printf("%f %f %f %f %f %f\n",xmax,ymax,xsid,ysid,xrat,yrat);*/
        for(k=0;k<NFRE;k++)
        {

                x1=xmin*rat+xsid;  
                y1=ymin*rat+ysid;
                x2=xwid*rat;   
                y2=ywid*rat;
                XDrawRectangle(disp,win,gc,(int)x1,(int)y1,(int)x2,(int)y2);
        }

        c=100;
        XSetForeground(disp,gc,color[c].pixel);
        vmax=sqrt(u[0]*u[0]+v[0]*v[0]);
        for(k=0;k<n;k++)
        {
                vv=sqrt(u[k]*u[k]+v[k]*v[k]);
                if(vv>=vmax)vmax=vv;
        }

        vel=atof(argv[3])*ratio/vmax;
        xd1=-8;
        yd1=3; 
        xd2=-8; 
        yd2=-3;
        for(j=0;j<10000;j++)
        {
                for(i=0;i<itt;i++)
                {
                        for(k=0;k<n;k++)
                        {
                                x0=x[k]*rat+xsid;
                                y0=y[k]*rat+ysid;

                                xq=x0+(u[k+n*i]*vel)*rat;
                                yq=y0+(v[k+n*i]*vel)*rat;
                                XDrawLine(disp,win,gc,(int)x0,(int)y0,(int)xq,(int)yq);
                                /*
                                XX=XQ-X0;
                                YY=YQ-Y0;
                                R=SQR(XX*XX+YY*YY);
                                R1=R+XD1;
                                R2=R+XD2;

                                switch(XX)
                                {
                                case 0:
                                        if(YY<=0)
                                                THE= 1.5708;
                                        else
                                                THE=-1.5708;
        
                                        break;
                                default:
                                        XY=ABS(YY/XX);
                                        if(XX>0 && YY<=0) THE = ATN(XY);
                                        if(XX<0 && YY<=0) THE =-ATN(XY)+3.14159265;
                                        if(XX<0 && YY>=0) THE = ATN(XY)-3.14159265;
                                        if(XX>0 && YY>=0) THE =-ATN(XY);
                                break;
                                }

                                X1= R1*COS(THE)+YD1*SIN(THE)+X0
                                Y1=-R1*SIN(THE)+YD1*COS(THE)+Y0
                                X2= R2*COS(THE)+YD2*SIN(THE)+X0
                                Y2=-R2*SIN(THE)+YD2*COS(THE)+Y0

                                XDrawLine(disp,win,gc,X1,Y1,XQ,YQ);
                                XDrawLine(disp,win,gc,X2,Y2,XQ,YQ);
                                XDrawLine(disp,win,gc,X1,Y1,X2,Y2);
*/
                                for(wai=0;wai<250;wai++)dummy=0;

                                }

                        XClearWindow(disp,win);
                        }
                }
        XFlush(disp);
/*      getchar();*/
}
